
#    Note:  This is loaded into the namespace  R3B

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable ASICList {0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15}
    variable ASIC [first $ASICList]

    variable allmodules 0

   proc  show_variables {} {
       variable allmodules 

       InsertLog "ASICs = $::R3B::ASICList"
       InsertLog "ASIC = $::R3B::ASIC"
       InsertLog "all modules = $allmodules"
   }

   proc probe_i2c {} {
       variable ASICList
       variable ASIC

       set ASICList {}
       for {set ASIC 0} {$ASIC <= 15} {incr ASIC} {
          set i 0
          set vl [time {ReadR3BASICRegister [expr ($ASIC << 10) + $i]}]
          if {[first $vl] < 50000} {lappend ASICList $ASIC}
       }

       set ASIC [first $ASICList]

       InsertLog "ASICs discovered $ASICList"
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {set ::R3B::R3B4k $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   I2C       {probe_i2c}

                   EXPERT   {$vl [third [lindex $cgidata 1]]}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
     }

}   ;# end of if {$started == 0}




