
#    Note:  This is loaded into the namespace  UASIC

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""
    
    variable HelpTopic "R3B"
    
    variable ASIC -
    catch {set ASIC [first $::R3B::ASICList]}

    variable allmodules 0
    variable allasics 0
    
#    ASIC parameters

     variable EnergyThresholdList {128 136 144 152 160 168 176 184 192 200 208 216 224 232 240 248 255}
     variable EnergyThresholdIDs  {"128 0x80" "136 0x88" "144 0x90" "152 0x98" "160 0xa0" "168 0xa8" "176 0xb0" \
           "184 0xb8" "192 0xc0" "200 0xc8" "208 0xd0" "216 0xd8" "224 0xe0" "232 0xe8" "240 0xf0" "248 0xf8" "255 0xff"}

     variable ChargeCarrier 0
     variable Neighbours 0
     variable ResetDelay 0
     variable TriggerLength 1
     variable ShapingTime 1
     variable DelayAfterPeak 0
     variable EnergyThreshold 0
     
   proc do_help {} {
      variable HelpTopic 

        set Txtfile [file join $HelpTopic.txt]
        set z [catch {open $Txtfile r} file]
        if {$z != 0} {
            Alert "Sorry unable to access $Txtfile\nInformation coming very soon!!\n"
            return
        }

        set text [read $file]
        close $file

        Alert "$text"
  }

   proc  show_variables {} {
       variable allmodules
       variable allasics
     variable ASIC
     variable ChargeCarrier
     variable Neighbours
     variable ResetDelay
     variable TriggerLength
     variable ShapingTime
     variable DelayAfterPeak
     variable EnergyThreshold

       InsertLog "R3B4K = $::R3B::R3B4K"
       InsertLog "all modules = $allmodules; all asics = $allasics"
       InsertLog "ASIC=$ASIC"
       InsertLog "Charge Carrier = $ChargeCarrier"
       InsertLog "Neighbours = $Neighbours"
       InsertLog "ResetDelay = $ResetDelay"
       InsertLog "TriggerLength = $TriggerLength"
       InsertLog "Shaping Time = $ShapingTime"
       InsertLog "Delay After Peak = $DelayAfterPeak"
       InsertLog "Energy Threshold = $EnergyThreshold"

   }

   proc do_redisplay {} {
      variable ASIC
     variable ChargeCarrier
     variable Neighbours
     variable ResetDelay
     variable TriggerLength
     variable ShapingTime
     variable DelayAfterPeak
     variable EnergyThreshold
      
      set vl [ReadR3BASICRegister [expr ($ASIC << 10) + 1]]

      set ChargeCarrier [expr ($vl >> 7) & 1]
      set Neighbours [expr ($vl >> 6) & 1]
      
      set vl [ReadR3BASICRegister [expr ($ASIC << 10) + 3]]
      set ResetDelay [expr ($vl >> 4) & 15]
      set TriggerLength [expr $vl & 15]
      
      set vl [ReadR3BASICRegister [expr ($ASIC << 10) + 4]]
      set ShapingTime [expr ($vl >> 4) & 15]
      set DelayAfterPeak [expr $vl & 15]
      
      set vl [ReadR3BASICRegister [expr ($ASIC << 10) + 15]]
      set EnergyThreshold $vl

   }

   proc do_SetASICReg {reg vl} {
     variable allasics
      variable ASIC
     variable ChargeCarrier
     variable Neighbours
     variable ResetDelay
     variable TriggerLength
     variable ShapingTime
     variable DelayAfterPeak
     variable EnergyThreshold
     
     set BAK $ASIC

     set ValMode [ReadR3BASICRegister [expr ($ASIC << 10) + 1]]
     
     foreach ASIC $::R3B::ASICList {
        if {$allasics == 0 && $ASIC != $BAK} continue

       set ValMode [expr [ReadR3BASICRegister [expr ($ASIC << 10) + 1]] & 0x30]
     
       switch $reg {
          Charge_Carrier   {set ChargeCarrier $vl; WriteR3BASICRegister [expr ($ASIC << 10) + 1] [expr ($ChargeCarrier << 7) + ($Neighbours << 6) + $ValMode]}
          Neighbour_Mode   {set Neighbours $vl; WriteR3BASICRegister [expr ($ASIC << 10) + 1] [expr ($ChargeCarrier << 7) + ($Neighbours << 6) + $ValMode]}
          Reset_Delay      {set ResetDelay $vl; WriteR3BASICRegister [expr ($ASIC << 10) + 3] [expr ($ResetDelay << 4) + $TriggerLength]}
          Trigger_Length   {set TriggerLength $vl; WriteR3BASICRegister [expr ($ASIC << 10) + 3] [expr ($ResetDelay << 4) + $TriggerLength]}
          Shaping_Time     {set ShapingTime $vl; WriteR3BASICRegister [expr ($ASIC << 10) + 4] [expr ($ShapingTime << 4) + $DelayAfterPeak]}
          Delay_after_Peak {set DelayAfterPeak $vl; WriteR3BASICRegister [expr ($ASIC << 10) + 4] [expr ($ShapingTime << 4) + $DelayAfterPeak]}
          Energy_Threshold {set EnergyThreshold $vl; WriteR3BASICRegister [expr ($ASIC << 10) + 15] $EnergyThreshold}
       }
     }
     
     set ASIC $BAK
   }

   proc do_expert {cmd} {
       variable ValCount

       switch $cmd {

          default {}
       }
   }
 
   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable HelpTopic

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]
              set p [third [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}
                   
                   HELP     {
                       switch $vl {
                          UASIC   {set HelpTopic "UASIC"}
                          default {set HelpTopic "R3B"}
                       }
                       do_help
                   }

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
                   
                   MODULE     {set ::R3B::R3B4K $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}
                   ALLASICS   {variable allasics; set allasics [expr ($allasics + 1) & 1]}
                   
                   ASIC     {variable ASIC; set ASIC $vl; do_redisplay}
                   
                   EXPERT   {do_expert $vl}
                   
                   ASICREG  {do_SetASICReg $vl $p}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

}   ;# end of if {$started == 0}




